Index: /branches/ClientUserManagement/HeuristicLab.Services.Access.DataAccess/3.3/ClientManagement.designer.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access.DataAccess/3.3/ClientManagement.designer.cs	(revision 6839)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access.DataAccess/3.3/ClientManagement.designer.cs	(revision 6840)
@@ -10,16 +10,23 @@
 //------------------------------------------------------------------------------
 
-namespace HeuristicLab.Services.Access.DataAccess {
-  using System;
-  using System.ComponentModel;
-  using System.Data.Linq;
-  using System.Data.Linq.Mapping;
-
-
-  [global::System.Data.Linq.Mapping.DatabaseAttribute(Name = "HeuristicLab.ClientManagement")]
-  public partial class ClientManagementDataContext : System.Data.Linq.DataContext {
-
-    private static System.Data.Linq.Mapping.MappingSource mappingSource = new AttributeMappingSource();
-
+namespace HeuristicLab.Services.Access.DataAccess
+{
+	using System.Data.Linq;
+	using System.Data.Linq.Mapping;
+	using System.Data;
+	using System.Collections.Generic;
+	using System.Reflection;
+	using System.Linq;
+	using System.Linq.Expressions;
+	using System.ComponentModel;
+	using System;
+	
+	
+	[global::System.Data.Linq.Mapping.DatabaseAttribute(Name="HeuristicLab.ClientManagement")]
+	public partial class ClientManagementDataContext : System.Data.Linq.DataContext
+	{
+		
+		private static System.Data.Linq.Mapping.MappingSource mappingSource = new AttributeMappingSource();
+		
     #region Extensibility Method Definitions
     partial void OnCreated();
@@ -61,129 +68,159 @@
     partial void DeleteUserGroupUserGroup(UserGroupUserGroup instance);
     #endregion
-
-    public ClientManagementDataContext() :
-      base(global::HeuristicLab.Services.Access.DataAccess.Properties.Settings.Default.HeuristicLab_ClientManagementConnectionString, mappingSource) {
-      OnCreated();
-    }
-
-    public ClientManagementDataContext(string connection) :
-      base(connection, mappingSource) {
-      OnCreated();
-    }
-
-    public ClientManagementDataContext(System.Data.IDbConnection connection) :
-      base(connection, mappingSource) {
-      OnCreated();
-    }
-
-    public ClientManagementDataContext(string connection, System.Data.Linq.Mapping.MappingSource mappingSource) :
-      base(connection, mappingSource) {
-      OnCreated();
-    }
-
-    public ClientManagementDataContext(System.Data.IDbConnection connection, System.Data.Linq.Mapping.MappingSource mappingSource) :
-      base(connection, mappingSource) {
-      OnCreated();
-    }
-
-    public System.Data.Linq.Table<Resource> Resources {
-      get {
-        return this.GetTable<Resource>();
-      }
-    }
-
-    public System.Data.Linq.Table<ResourceResourceGroup> ResourceResourceGroups {
-      get {
-        return this.GetTable<ResourceResourceGroup>();
-      }
-    }
-
-    public System.Data.Linq.Table<ClientLog> ClientLogs {
-      get {
-        return this.GetTable<ClientLog>();
-      }
-    }
-
-    public System.Data.Linq.Table<ClientError> ClientErrors {
-      get {
-        return this.GetTable<ClientError>();
-      }
-    }
-
-    public System.Data.Linq.Table<UserGroupBase> UserGroupBases {
-      get {
-        return this.GetTable<UserGroupBase>();
-      }
-    }
-
-    public System.Data.Linq.Table<ClientType> ClientTypes {
-      get {
-        return this.GetTable<ClientType>();
-      }
-    }
-
-    public System.Data.Linq.Table<OperatingSystem> OperatingSystems {
-      get {
-        return this.GetTable<OperatingSystem>();
-      }
-    }
-
-    public System.Data.Linq.Table<Country> Countries {
-      get {
-        return this.GetTable<Country>();
-      }
-    }
-
-    public System.Data.Linq.Table<ClientConfiguration> ClientConfigurations {
-      get {
-        return this.GetTable<ClientConfiguration>();
-      }
-    }
-
-    public System.Data.Linq.Table<Plugin> Plugins {
-      get {
-        return this.GetTable<Plugin>();
-      }
-    }
-
-    public System.Data.Linq.Table<ResourcePlugin> ResourcePlugins {
-      get {
-        return this.GetTable<ResourcePlugin>();
-      }
-    }
-
-    public System.Data.Linq.Table<UserGroupUserGroup> UserGroupUserGroups {
-      get {
-        return this.GetTable<UserGroupUserGroup>();
-      }
-    }
-  }
-
-  [global::System.Data.Linq.Mapping.TableAttribute(Name = "dbo.Resource")]
-  [global::System.Data.Linq.Mapping.InheritanceMappingAttribute(Code = "Resource", Type = typeof(Resource))]
-  [global::System.Data.Linq.Mapping.InheritanceMappingAttribute(Code = "Client", Type = typeof(Client), IsDefault = true)]
-  [global::System.Data.Linq.Mapping.InheritanceMappingAttribute(Code = "ClientGroup", Type = typeof(ClientGroup))]
-  public partial class Resource : INotifyPropertyChanging, INotifyPropertyChanged {
-
-    private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
-
-    private System.Guid _Id;
-
-    private string _Name;
-
-    private string _Description;
-
-    private string _Type;
-
-    private EntitySet<ResourceResourceGroup> _ResourceResourceGroups;
-
-    private EntitySet<ResourceResourceGroup> _ResourceResourceGroups1;
-
-    private EntitySet<ClientLog> _ClientLogs;
-
-    private EntitySet<ClientError> _ClientErrors;
-
-    private EntitySet<ResourcePlugin> _ResourcePlugins;
-
+		
+		public ClientManagementDataContext() : 
+				base(global::HeuristicLab.Services.Access.DataAccess.Properties.Settings.Default.HeuristicLab_ClientManagementConnectionString, mappingSource)
+		{
+			OnCreated();
+		}
+		
+		public ClientManagementDataContext(string connection) : 
+				base(connection, mappingSource)
+		{
+			OnCreated();
+		}
+		
+		public ClientManagementDataContext(System.Data.IDbConnection connection) : 
+				base(connection, mappingSource)
+		{
+			OnCreated();
+		}
+		
+		public ClientManagementDataContext(string connection, System.Data.Linq.Mapping.MappingSource mappingSource) : 
+				base(connection, mappingSource)
+		{
+			OnCreated();
+		}
+		
+		public ClientManagementDataContext(System.Data.IDbConnection connection, System.Data.Linq.Mapping.MappingSource mappingSource) : 
+				base(connection, mappingSource)
+		{
+			OnCreated();
+		}
+		
+		public System.Data.Linq.Table<Resource> Resources
+		{
+			get
+			{
+				return this.GetTable<Resource>();
+			}
+		}
+		
+		public System.Data.Linq.Table<ResourceResourceGroup> ResourceResourceGroups
+		{
+			get
+			{
+				return this.GetTable<ResourceResourceGroup>();
+			}
+		}
+		
+		public System.Data.Linq.Table<ClientLog> ClientLogs
+		{
+			get
+			{
+				return this.GetTable<ClientLog>();
+			}
+		}
+		
+		public System.Data.Linq.Table<ClientError> ClientErrors
+		{
+			get
+			{
+				return this.GetTable<ClientError>();
+			}
+		}
+		
+		public System.Data.Linq.Table<UserGroupBase> UserGroupBases
+		{
+			get
+			{
+				return this.GetTable<UserGroupBase>();
+			}
+		}
+		
+		public System.Data.Linq.Table<ClientType> ClientTypes
+		{
+			get
+			{
+				return this.GetTable<ClientType>();
+			}
+		}
+		
+		public System.Data.Linq.Table<OperatingSystem> OperatingSystems
+		{
+			get
+			{
+				return this.GetTable<OperatingSystem>();
+			}
+		}
+		
+		public System.Data.Linq.Table<Country> Countries
+		{
+			get
+			{
+				return this.GetTable<Country>();
+			}
+		}
+		
+		public System.Data.Linq.Table<ClientConfiguration> ClientConfigurations
+		{
+			get
+			{
+				return this.GetTable<ClientConfiguration>();
+			}
+		}
+		
+		public System.Data.Linq.Table<Plugin> Plugins
+		{
+			get
+			{
+				return this.GetTable<Plugin>();
+			}
+		}
+		
+		public System.Data.Linq.Table<ResourcePlugin> ResourcePlugins
+		{
+			get
+			{
+				return this.GetTable<ResourcePlugin>();
+			}
+		}
+		
+		public System.Data.Linq.Table<UserGroupUserGroup> UserGroupUserGroups
+		{
+			get
+			{
+				return this.GetTable<UserGroupUserGroup>();
+			}
+		}
+	}
+	
+	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.Resource")]
+	[global::System.Data.Linq.Mapping.InheritanceMappingAttribute(Code="Resource", Type=typeof(Resource))]
+	[global::System.Data.Linq.Mapping.InheritanceMappingAttribute(Code="Client", Type=typeof(Client), IsDefault=true)]
+	[global::System.Data.Linq.Mapping.InheritanceMappingAttribute(Code="ClientGroup", Type=typeof(ClientGroup))]
+	public partial class Resource : INotifyPropertyChanging, INotifyPropertyChanged
+	{
+		
+		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
+		
+		private System.Guid _Id;
+		
+		private string _Name;
+		
+		private string _Description;
+		
+		private string _Type;
+		
+		private EntitySet<ResourceResourceGroup> _ResourceResourceGroups;
+		
+		private EntitySet<ResourceResourceGroup> _ResourceResourceGroups1;
+		
+		private EntitySet<ClientLog> _ClientLogs;
+		
+		private EntitySet<ClientError> _ClientErrors;
+		
+		private EntitySet<ResourcePlugin> _ResourcePlugins;
+		
     #region Extensibility Method Definitions
     partial void OnLoaded();
@@ -199,237 +236,276 @@
     partial void OnTypeChanged();
     #endregion
-
-    public Resource() {
-      this._ResourceResourceGroups = new EntitySet<ResourceResourceGroup>(new Action<ResourceResourceGroup>(this.attach_ResourceResourceGroups), new Action<ResourceResourceGroup>(this.detach_ResourceResourceGroups));
-      this._ResourceResourceGroups1 = new EntitySet<ResourceResourceGroup>(new Action<ResourceResourceGroup>(this.attach_ResourceResourceGroups1), new Action<ResourceResourceGroup>(this.detach_ResourceResourceGroups1));
-      this._ClientLogs = new EntitySet<ClientLog>(new Action<ClientLog>(this.attach_ClientLogs), new Action<ClientLog>(this.detach_ClientLogs));
-      this._ClientErrors = new EntitySet<ClientError>(new Action<ClientError>(this.attach_ClientErrors), new Action<ClientError>(this.detach_ClientErrors));
-      this._ResourcePlugins = new EntitySet<ResourcePlugin>(new Action<ResourcePlugin>(this.attach_ResourcePlugins), new Action<ResourcePlugin>(this.detach_ResourcePlugins));
-      OnCreated();
-    }
-
-    [global::System.Data.Linq.Mapping.ColumnAttribute(Storage = "_Id", AutoSync = AutoSync.OnInsert, DbType = "UniqueIdentifier NOT NULL", IsPrimaryKey = true, IsDbGenerated = true)]
-    public System.Guid Id {
-      get {
-        return this._Id;
-      }
-      set {
-        if ((this._Id != value)) {
-          this.OnIdChanging(value);
-          this.SendPropertyChanging();
-          this._Id = value;
-          this.SendPropertyChanged("Id");
-          this.OnIdChanged();
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.ColumnAttribute(Storage = "_Name", DbType = "NVarChar(MAX) NOT NULL", CanBeNull = false)]
-    public string Name {
-      get {
-        return this._Name;
-      }
-      set {
-        if ((this._Name != value)) {
-          this.OnNameChanging(value);
-          this.SendPropertyChanging();
-          this._Name = value;
-          this.SendPropertyChanged("Name");
-          this.OnNameChanged();
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.ColumnAttribute(Storage = "_Description", DbType = "NVarChar(MAX)", CanBeNull = false)]
-    public string Description {
-      get {
-        return this._Description;
-      }
-      set {
-        if ((this._Description != value)) {
-          this.OnDescriptionChanging(value);
-          this.SendPropertyChanging();
-          this._Description = value;
-          this.SendPropertyChanged("Description");
-          this.OnDescriptionChanged();
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.ColumnAttribute(Storage = "_Type", DbType = "NVarChar(MAX) NOT NULL", CanBeNull = false, IsDiscriminator = true)]
-    public string Type {
-      get {
-        return this._Type;
-      }
-      set {
-        if ((this._Type != value)) {
-          this.OnTypeChanging(value);
-          this.SendPropertyChanging();
-          this._Type = value;
-          this.SendPropertyChanged("Type");
-          this.OnTypeChanged();
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.AssociationAttribute(Name = "Resource_ResourceResourceGroup", Storage = "_ResourceResourceGroups", ThisKey = "Id", OtherKey = "ResourceGroupId")]
-    public EntitySet<ResourceResourceGroup> ResourceResourceGroupsChilds {
-      get {
-        return this._ResourceResourceGroups;
-      }
-      set {
-        this._ResourceResourceGroups.Assign(value);
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.AssociationAttribute(Name = "Resource_ResourceResourceGroup1", Storage = "_ResourceResourceGroups1", ThisKey = "Id", OtherKey = "ResourceId")]
-    public EntitySet<ResourceResourceGroup> ResourceResourceGroupsParents {
-      get {
-        return this._ResourceResourceGroups1;
-      }
-      set {
-        this._ResourceResourceGroups1.Assign(value);
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.AssociationAttribute(Name = "Resource_ClientLog", Storage = "_ClientLogs", ThisKey = "Id", OtherKey = "ResourceId")]
-    public EntitySet<ClientLog> ClientLogs {
-      get {
-        return this._ClientLogs;
-      }
-      set {
-        this._ClientLogs.Assign(value);
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.AssociationAttribute(Name = "Resource_ClientError", Storage = "_ClientErrors", ThisKey = "Id", OtherKey = "ClientId")]
-    public EntitySet<ClientError> ClientErrors {
-      get {
-        return this._ClientErrors;
-      }
-      set {
-        this._ClientErrors.Assign(value);
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.AssociationAttribute(Name = "Resource_ResourcePlugin", Storage = "_ResourcePlugins", ThisKey = "Id", OtherKey = "ResourceId")]
-    public EntitySet<ResourcePlugin> ResourcePlugins {
-      get {
-        return this._ResourcePlugins;
-      }
-      set {
-        this._ResourcePlugins.Assign(value);
-      }
-    }
-
-    public event PropertyChangingEventHandler PropertyChanging;
-
-    public event PropertyChangedEventHandler PropertyChanged;
-
-    protected virtual void SendPropertyChanging() {
-      if ((this.PropertyChanging != null)) {
-        this.PropertyChanging(this, emptyChangingEventArgs);
-      }
-    }
-
-    protected virtual void SendPropertyChanged(String propertyName) {
-      if ((this.PropertyChanged != null)) {
-        this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
-      }
-    }
-
-    private void attach_ResourceResourceGroups(ResourceResourceGroup entity) {
-      this.SendPropertyChanging();
-      entity.ParentResource = this;
-    }
-
-    private void detach_ResourceResourceGroups(ResourceResourceGroup entity) {
-      this.SendPropertyChanging();
-      entity.ParentResource = null;
-    }
-
-    private void attach_ResourceResourceGroups1(ResourceResourceGroup entity) {
-      this.SendPropertyChanging();
-      entity.Resource = this;
-    }
-
-    private void detach_ResourceResourceGroups1(ResourceResourceGroup entity) {
-      this.SendPropertyChanging();
-      entity.Resource = null;
-    }
-
-    private void attach_ClientLogs(ClientLog entity) {
-      this.SendPropertyChanging();
-      entity.Resource = this;
-    }
-
-    private void detach_ClientLogs(ClientLog entity) {
-      this.SendPropertyChanging();
-      entity.Resource = null;
-    }
-
-    private void attach_ClientErrors(ClientError entity) {
-      this.SendPropertyChanging();
-      entity.Resource = this;
-    }
-
-    private void detach_ClientErrors(ClientError entity) {
-      this.SendPropertyChanging();
-      entity.Resource = null;
-    }
-
-    private void attach_ResourcePlugins(ResourcePlugin entity) {
-      this.SendPropertyChanging();
-      entity.Resource = this;
-    }
-
-    private void detach_ResourcePlugins(ResourcePlugin entity) {
-      this.SendPropertyChanging();
-      entity.Resource = null;
-    }
-  }
-
-  public partial class Client : Resource {
-
-    private System.Guid _ClientConfigurationId;
-
-    private System.Guid _ClientType;
-
-    private string _HeuristicLabVersion;
-
-    private System.Guid _Country;
-
-    private System.Guid _OperatingSystem;
-
-    private System.Nullable<int> _MemorySize;
-
-    private System.Nullable<System.DateTime> _Timestamp;
-
-    private System.Nullable<int> _NumberOfCores;
-
-    private string _ProcessorType;
-
-    private EntityRef<ClientType> _ClientTypes;
-
-    private EntityRef<OperatingSystem> _OperatingSystems;
-
-    private EntityRef<Country> _Countries;
-
-    private EntityRef<ClientConfiguration> _ClientConfiguration;
-
+		
+		public Resource()
+		{
+			this._ResourceResourceGroups = new EntitySet<ResourceResourceGroup>(new Action<ResourceResourceGroup>(this.attach_ResourceResourceGroups), new Action<ResourceResourceGroup>(this.detach_ResourceResourceGroups));
+			this._ResourceResourceGroups1 = new EntitySet<ResourceResourceGroup>(new Action<ResourceResourceGroup>(this.attach_ResourceResourceGroups1), new Action<ResourceResourceGroup>(this.detach_ResourceResourceGroups1));
+			this._ClientLogs = new EntitySet<ClientLog>(new Action<ClientLog>(this.attach_ClientLogs), new Action<ClientLog>(this.detach_ClientLogs));
+			this._ClientErrors = new EntitySet<ClientError>(new Action<ClientError>(this.attach_ClientErrors), new Action<ClientError>(this.detach_ClientErrors));
+			this._ResourcePlugins = new EntitySet<ResourcePlugin>(new Action<ResourcePlugin>(this.attach_ResourcePlugins), new Action<ResourcePlugin>(this.detach_ResourcePlugins));
+			OnCreated();
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Id", AutoSync=AutoSync.OnInsert, DbType="UniqueIdentifier NOT NULL", IsPrimaryKey=true, IsDbGenerated=true)]
+		public System.Guid Id
+		{
+			get
+			{
+				return this._Id;
+			}
+			set
+			{
+				if ((this._Id != value))
+				{
+					this.OnIdChanging(value);
+					this.SendPropertyChanging();
+					this._Id = value;
+					this.SendPropertyChanged("Id");
+					this.OnIdChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Name", DbType="NVarChar(MAX) NOT NULL", CanBeNull=false)]
+		public string Name
+		{
+			get
+			{
+				return this._Name;
+			}
+			set
+			{
+				if ((this._Name != value))
+				{
+					this.OnNameChanging(value);
+					this.SendPropertyChanging();
+					this._Name = value;
+					this.SendPropertyChanged("Name");
+					this.OnNameChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Description", DbType="NVarChar(MAX)", CanBeNull=false)]
+		public string Description
+		{
+			get
+			{
+				return this._Description;
+			}
+			set
+			{
+				if ((this._Description != value))
+				{
+					this.OnDescriptionChanging(value);
+					this.SendPropertyChanging();
+					this._Description = value;
+					this.SendPropertyChanged("Description");
+					this.OnDescriptionChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Type", DbType="NVarChar(MAX) NOT NULL", CanBeNull=false, IsDiscriminator=true)]
+		public string Type
+		{
+			get
+			{
+				return this._Type;
+			}
+			set
+			{
+				if ((this._Type != value))
+				{
+					this.OnTypeChanging(value);
+					this.SendPropertyChanging();
+					this._Type = value;
+					this.SendPropertyChanged("Type");
+					this.OnTypeChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Resource_ResourceResourceGroup", Storage="_ResourceResourceGroups", ThisKey="Id", OtherKey="ResourceGroupId")]
+		public EntitySet<ResourceResourceGroup> ResourceResourceGroupsChilds
+		{
+			get
+			{
+				return this._ResourceResourceGroups;
+			}
+			set
+			{
+				this._ResourceResourceGroups.Assign(value);
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Resource_ResourceResourceGroup1", Storage="_ResourceResourceGroups1", ThisKey="Id", OtherKey="ResourceId")]
+		public EntitySet<ResourceResourceGroup> ResourceResourceGroupsParents
+		{
+			get
+			{
+				return this._ResourceResourceGroups1;
+			}
+			set
+			{
+				this._ResourceResourceGroups1.Assign(value);
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Resource_ClientLog", Storage="_ClientLogs", ThisKey="Id", OtherKey="ResourceId")]
+		public EntitySet<ClientLog> ClientLogs
+		{
+			get
+			{
+				return this._ClientLogs;
+			}
+			set
+			{
+				this._ClientLogs.Assign(value);
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Resource_ClientError", Storage="_ClientErrors", ThisKey="Id", OtherKey="ClientId")]
+		public EntitySet<ClientError> ClientErrors
+		{
+			get
+			{
+				return this._ClientErrors;
+			}
+			set
+			{
+				this._ClientErrors.Assign(value);
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Resource_ResourcePlugin", Storage="_ResourcePlugins", ThisKey="Id", OtherKey="ResourceId")]
+		public EntitySet<ResourcePlugin> ResourcePlugins
+		{
+			get
+			{
+				return this._ResourcePlugins;
+			}
+			set
+			{
+				this._ResourcePlugins.Assign(value);
+			}
+		}
+		
+		public event PropertyChangingEventHandler PropertyChanging;
+		
+		public event PropertyChangedEventHandler PropertyChanged;
+		
+		protected virtual void SendPropertyChanging()
+		{
+			if ((this.PropertyChanging != null))
+			{
+				this.PropertyChanging(this, emptyChangingEventArgs);
+			}
+		}
+		
+		protected virtual void SendPropertyChanged(String propertyName)
+		{
+			if ((this.PropertyChanged != null))
+			{
+				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
+			}
+		}
+		
+		private void attach_ResourceResourceGroups(ResourceResourceGroup entity)
+		{
+			this.SendPropertyChanging();
+			entity.ParentResource = this;
+		}
+		
+		private void detach_ResourceResourceGroups(ResourceResourceGroup entity)
+		{
+			this.SendPropertyChanging();
+			entity.ParentResource = null;
+		}
+		
+		private void attach_ResourceResourceGroups1(ResourceResourceGroup entity)
+		{
+			this.SendPropertyChanging();
+			entity.Resource = this;
+		}
+		
+		private void detach_ResourceResourceGroups1(ResourceResourceGroup entity)
+		{
+			this.SendPropertyChanging();
+			entity.Resource = null;
+		}
+		
+		private void attach_ClientLogs(ClientLog entity)
+		{
+			this.SendPropertyChanging();
+			entity.Resource = this;
+		}
+		
+		private void detach_ClientLogs(ClientLog entity)
+		{
+			this.SendPropertyChanging();
+			entity.Resource = null;
+		}
+		
+		private void attach_ClientErrors(ClientError entity)
+		{
+			this.SendPropertyChanging();
+			entity.Resource = this;
+		}
+		
+		private void detach_ClientErrors(ClientError entity)
+		{
+			this.SendPropertyChanging();
+			entity.Resource = null;
+		}
+		
+		private void attach_ResourcePlugins(ResourcePlugin entity)
+		{
+			this.SendPropertyChanging();
+			entity.Resource = this;
+		}
+		
+		private void detach_ResourcePlugins(ResourcePlugin entity)
+		{
+			this.SendPropertyChanging();
+			entity.Resource = null;
+		}
+	}
+	
+	public partial class Client : Resource
+	{
+		
+		private string _HeuristicLabVersion;
+		
+		private System.Nullable<int> _MemorySize;
+		
+		private System.Nullable<System.DateTime> _Timestamp;
+		
+		private System.Nullable<int> _NumberOfCores;
+		
+		private string _ProcessorType;
+		
+		private System.Guid _ClientTypeId;
+		
+		private System.Guid _OperatingSystemId;
+		
+		private System.Guid _ClientConfigurationId;
+		
+		private System.Guid _CountryId;
+		
+		private EntityRef<ClientType> _ClientType;
+		
+		private EntityRef<OperatingSystem> _OperatingSystem;
+		
+		private EntityRef<Country> _Country;
+		
+		private EntityRef<ClientConfiguration> _ClientConfiguration;
+		
     #region Extensibility Method Definitions
     partial void OnLoaded();
     partial void OnValidate(System.Data.Linq.ChangeAction action);
     partial void OnCreated();
-    partial void OnClientConfigurationIdChanging(System.Guid value);
-    partial void OnClientConfigurationIdChanged();
-    partial void OnClientTypeIdChanging(System.Guid value);
-    partial void OnClientTypeIdChanged();
     partial void OnHeuristicLabVersionChanging(string value);
     partial void OnHeuristicLabVersionChanged();
-    partial void OnCountryIdChanging(System.Guid value);
-    partial void OnCountryIdChanged();
-    partial void OnOperatingSystemIdChanging(System.Guid value);
-    partial void OnOperatingSystemIdChanged();
     partial void OnMemorySizeChanging(System.Nullable<int> value);
     partial void OnMemorySizeChanged();
